"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _MIBORXQWcjs = require('../__chunks/MIBORXQW.cjs');





var _6TI3NXX6cjs = require('../__chunks/6TI3NXX6.cjs');


var _L5A2ID7Scjs = require('../__chunks/L5A2ID7S.cjs');
require('../__chunks/FDRJDQ5Y.cjs');




var _7EQBAZ46cjs = require('../__chunks/7EQBAZ46.cjs');

// src/composite/composite-input.tsx




var _dom = require('@ariakit/core/utils/dom');
var _misc = require('@ariakit/core/utils/misc');
var _react = require('react');
var TagName = "input";
function getValueLength(element) {
  if (_dom.isTextField.call(void 0, element)) {
    return element.value.length;
  } else if (element.isContentEditable) {
    const range = _dom.getDocument.call(void 0, element).createRange();
    range.selectNodeContents(element);
    return range.toString().length;
  }
  return 0;
}
var useCompositeInput = _6TI3NXX6cjs.createHook.call(void 0, 
  function useCompositeInput2(_a) {
    var _b = _a, { store } = _b, props = _7EQBAZ46cjs.__objRest.call(void 0, _b, ["store"]);
    const onKeyDownCaptureProp = props.onKeyDownCapture;
    if (process.env.NODE_ENV !== "production") {
      _react.useEffect.call(void 0, () => {
        console.warn(
          "CompositeInput is deprecated. Use `<CompositeItem render={<input />}>` instead."
        );
      }, []);
    }
    const onKeyDownCapture = _L5A2ID7Scjs.useEvent.call(void 0, (event) => {
      onKeyDownCaptureProp == null ? void 0 : onKeyDownCaptureProp(event);
      if (event.defaultPrevented) return;
      const element = event.currentTarget;
      if (!element.isContentEditable && !_dom.isTextField.call(void 0, element)) return;
      const selection = _dom.getTextboxSelection.call(void 0, element);
      const { orientation } = (store == null ? void 0 : store.getState()) || {};
      const isHorizontal = orientation !== "vertical";
      const isVertical = orientation !== "horizontal";
      const isLeft = isHorizontal && event.key === "ArrowLeft";
      const isRight = isHorizontal && event.key === "ArrowRight";
      const isUp = isVertical && event.key === "ArrowUp";
      const isDown = isVertical && event.key === "ArrowDown";
      if (isRight || isDown) {
        if (selection.end !== getValueLength(element)) {
          event.stopPropagation();
        }
      } else if (isLeft || isUp) {
        if (selection.start !== 0) {
          event.stopPropagation();
        }
      }
    });
    const onFocusProp = props.onFocus;
    const onFocus = _L5A2ID7Scjs.useEvent.call(void 0, (event) => {
      onFocusProp == null ? void 0 : onFocusProp(event);
      if (event.defaultPrevented) return;
      _MIBORXQWcjs.selectTextField.call(void 0, event.currentTarget);
    });
    props = _7EQBAZ46cjs.__spreadProps.call(void 0, _7EQBAZ46cjs.__spreadValues.call(void 0, {}, props), {
      onKeyDownCapture,
      onFocus
    });
    return _misc.removeUndefinedValues.call(void 0, props);
  }
);
var CompositeInput = _6TI3NXX6cjs.memo.call(void 0, 
  _6TI3NXX6cjs.forwardRef.call(void 0, function CompositeInput2(props) {
    const htmlProps = useCompositeInput(props);
    return _6TI3NXX6cjs.createElement.call(void 0, TagName, htmlProps);
  })
);



exports.CompositeInput = CompositeInput; exports.useCompositeInput = useCompositeInput;
